/*
 * @Author: wuhao930406 1148547900@qq.com
 * @Date: 2023-10-17 10:14:53
 * @LastEditors: wuhao930406 1148547900@qq.com
 * @LastEditTime: 2023-10-17 15:58:12
 * @FilePath: /standaloneframe/frontend/src/layouts/index.jsx
 * @Description: 
 * 
 * Copyright (c) 2023 by ${git_name_email}, All Rights Reserved. 
 */
import { Link, Outlet, history } from "umi";
import { Button, ConfigProvider, theme, Segmented, Space, Divider } from "antd";
import styles from "./index.less";
import React, { useState, useEffect } from "react";
import { AppstoreOutlined, BarsOutlined } from "@ant-design/icons";
import IconFont from "@/components/IconFont";
import Switches from "@/components/Switches";
import zhCN from "antd/locale/zh_CN";
import "dayjs/locale/zh-cn";
import dayjs from "dayjs";
import themeconfig from "./components/theme";

dayjs.locale("zh-cn");

export default function Layout() {
  const [mode, setmode] = useState("light");
  return (
    <ConfigProvider
      theme={{
        algorithm: theme.darkAlgorithm,
        ...themeconfig,
      }}
      locale={zhCN}
    >
      <div
        style={{ backgroundColor:"#363636" }}
      >
        <div className="drag"></div>
        {/* <Space
          align="center"
          direction="horizontal"
          split={<Divider type="vertical" />}
          style={{
            justifyContent: "space-bewteen",
            position: "fixed",
            zIndex: 9999,
            right: 24,
            top: 26,
          }}
        >
          <Switches
            value={mode}
            onChange={(val) => {
              setmode(val);
            }}
          ></Switches>
        </Space> */}
        <Outlet context={{ mode }} />
      </div>
    </ConfigProvider>
  );
}
